<script setup lang="ts">
import { ref, onMounted } from 'vue';
import axios from 'axios';
import type { Customer } from './CustomerPortal.vue';
import router from '@/router';
const customerManagerName = ref<string>();
const creatorName = ref<string>()
const modifierName = ref<string>()
// TODO: fetch by name
const customerId = ref("10023");
const customerInfo = ref<Customer | null>(null);

const fetchCustomerInfo = async () => {
    try {
        const response = await axios.get<Customer>(`http://localhost:8080/api/v1/customers/${customerId.value}`);
        customerInfo.value = response.data;
        const creatorId = response.data.creatorId;
        const modifierId = response.data.modifierId;
        const creatorResponse = await axios.get(`http://localhost:8080/api/v1/managers/${creatorId}`);
        const modifierResponse = await axios.get(`http://localhost:8080/api/v1/managers/${modifierId}`);
        const customerManagerRelationshipResponse = await axios.get(`http://localhost:8080/api/v1/relationships/customers/${customerId.value}`);
        creatorName.value = creatorResponse.data;
        modifierName.value = modifierResponse.data;
        customerManagerName.value = customerManagerRelationshipResponse.data;
    } catch (error) {
        console.error('Error fetching customer information:', error);
    }
};

function saveToLocal() {
    const data = {
        customerInfo: customerInfo.value,
        creatorName: creatorName.value,
        modifierName: modifierName.value,
        customerManagerName: customerManagerName.value,
    };
    localStorage.setItem(`customer-${customerId.value}`, JSON.stringify(data));
}   

function gotoEdit() {
    saveToLocal();
    router.push({
        name: 'customer-edit',
        params: { id: customerId.value }
    });
}


onMounted(fetchCustomerInfo);
</script>

<template>
    <div>
        <div class="center-button-group">
            <el-button type="primary" plain size="small" class="button-group-auto-l-margin" @click="gotoEdit">編集</el-button>
            <el-button type="primary" plain size="small">削除</el-button>
            <el-button type="primary" plain size="small" class="button-group-auto-l-margin">コピー</el-button>
            <span class="red-must-filled-item"></span>
        </div>
        <el-skeleton v-if="!customerInfo" :rows="4" style="width: 90%; max-width: 1200px; margin: 0 auto;"></el-skeleton>
        <el-card v-else header="取引先情報">
            <el-row>
                <el-col :span="12">
                    <el-typography :title="customerInfo.name" :level="3">
                        取引先所有者: {{ customerManagerName }}
                    </el-typography>
                </el-col>
            </el-row>
            <el-row>
                <el-col :span="12">
                    <el-typography :title="customerInfo.name" :level="3">
                        取引先名: {{ customerInfo.name }}
                    </el-typography>
                </el-col>
                <el-col :span="12">
                    <el-typography :title="customerInfo.fax" :level="3">
                        FAX: {{ customerInfo.fax }}
                    </el-typography>
                </el-col>
            </el-row>
            <el-row>
                <el-col :span="12">
                    <el-typography :title="customerInfo.telephone" :level="3">
                        電話番号: {{ customerInfo.telephone }}
                    </el-typography>
                </el-col>
                <el-col :span="12">
                    <el-typography :title="customerInfo.website" :level="3">
                        Webサイト: {{ customerInfo.website }}
                    </el-typography>
                </el-col>
            </el-row>
        </el-card>
        <br>
        <el-skeleton v-if="!customerInfo" :rows="4" style="width: 90%; max-width: 1200px; margin: 0 auto;"></el-skeleton>
        <el-card v-else header="詳細情報">
            <el-row>
                <el-col :span="12">
                    <el-typography :title="customerInfo.address" :level="3">
                        住所: {{ customerInfo.address }}
                    </el-typography>
                </el-col>
                <el-col :span="12">
                    <el-typography :title="customerInfo.postalCode" :level="3">
                        郵便コード: {{ customerInfo.postalCode }}
                    </el-typography>
                </el-col>
            </el-row>
            <el-row>
                <el-col :span="12">
                    <el-typography :title="customerInfo.industry" :level="3">
                        得意分野: {{ customerInfo.industry }}
                    </el-typography>
                </el-col>
                <el-col :span="12">
                    <el-typography :title="customerInfo.headcount" :level="3">
                        従業員数: {{ customerInfo.headcount }}
                    </el-typography>
                </el-col>
            </el-row>
            <el-row>
                <el-col :span="12">
                    <el-typography :title="customerInfo.type" :level="3">
                        取引先の種別: {{ customerInfo.type }}
                    </el-typography>
                </el-col>
                <el-col :span="12">
                    <el-typography :title="customerInfo.annualRevenue" :level="3">
                        年間売上: {{ customerInfo.annualRevenue }}
                    </el-typography>
                </el-col>
            </el-row>
            <el-row>
                <el-col :span="12">
                    <el-typography :title="customerInfo.bankName" :level="3">
                        銀行名: {{ customerInfo.bankName }}
                    </el-typography>
                </el-col>
                <el-col :span="12">
                    <el-typography :title="customerInfo.branchName" :level="3">
                        支店名: {{ customerInfo.branchName }}
                    </el-typography>
                </el-col>
            </el-row>
            <el-row>
                <el-col :span="12">
                    <el-typography :title="customerInfo.accountNumber" :level="3">
                        口座番号: {{ customerInfo.accountNumber }}
                    </el-typography>
                </el-col>
                <el-col :span="12">
                    <el-typography :title="customerInfo.paymentTerm" :level="3">
                        支払サイト: {{ customerInfo.paymentTerm }}
                    </el-typography>
                </el-col>
            </el-row>
        </el-card>
        <br>
        <el-skeleton v-if="!customerInfo" :rows="4" style="width: 90%; max-width: 1200px; margin: 0 auto;"></el-skeleton>
        <el-card v-else header="システム情報">
            <el-row>
                <el-col :span="12">
                    <el-typography :title="customerInfo.creatorId" :level="3">
                        作成者: {{ creatorName }} {{ customerInfo.createdTime }}
                    </el-typography>
                </el-col>
                <el-col :span="12">
                    <el-typography :title="customerInfo.modifierId" :level="3">
                        最終更新者: {{ modifierName }} {{ customerInfo.modifiedTime }}
                    </el-typography>
                </el-col>
            </el-row>
        </el-card>
    </div>
</template>
  
<style>
.center-button-group {
    display: flex;
    justify-content: center;
    margin-top: 12px;
    margin-bottom: 30px;
}

.el-card .el-card__header {
    font-size: 16px;
    font-weight: bold;
    background-color: rgb(198, 217, 241);
    padding: 6px;
}

.el-card .el-card__body {
    background-color: rgb(242, 242, 242);
    font-size: 12px
}
</style>